set colsep ","
set pagesize 0
set lin 300
set feed off
set term off
set verify off

spool &1..txt

SELECT
	RTRIM(A.COLUMN_NAME, ' ')
	, CASE WHEN
	(
		A.DATA_TYPE = 'VARCHAR2'
		OR A.DATA_TYPE = 'CHAR'
	) THEN
		'CHAR'
	ELSE
		A.DATA_TYPE
	END IF
	, CASE WHEN A.DATA_TYPE = 'NUMBER' THEN
		A.DATA_PRECISION
	ELSE
		A.DATA_LENGTH
	END IF
	, A.DATA_SCALE
	, NVL2(B.COLUMN_NAME, '1', '0')
FROM
	USER_TAB_COLUMNS A
	, (
		SELECT
			B.TABLE_NAME
			, B.COLUMN_NAME
		FROM
			USER_CONS_COLUMNS B
			, USER_CONSTRAINTS C
		WHERE
			B.CONSTRAINT_NAME = C.CONSTRAINT_NAME
			AND C.CONSTRAINT_TYPE = 'P'
	) B
WHERE
	A.TABLE_NAME = B.TABLE_NAME (+)
	AND A.COLUMN_NAME = B.COLUMN_NAME (+)
	AND A.TABLE_NAME = '&1'
ORDER BY
	A.COLUMN_ID
/

spool off

quit