' --------------------------------------------------------------------------------
' C
' --------------------------------------------------------------------------------
' `FbN
If WScript.Arguments.count <> 2 Then
	WScript.Echo "Usage: makedata.vbs [configFileName] [numData]"
	WScript.Quit(1)
Else
	configFileName = WScript.Arguments(0)
	numData = WScript.Arguments(1)
End If

' ݒt@C̓ǂݍ
Set conf = readConfig(configFileName)

' ̃f[^
For i = 0 to (numData - 1)
	currentNumber = i
	lineData = ""

	For Each key In conf.keys
		confLine = conf.Item(key)
	
		' ږ
		itemName = RTrim(confLine(0))
		' ^Cv
		itemType = RTrim(confLine(1))
		itemType = LCase(itemType)
		' ڒ
		length = RTrim(confLine(2))
		' x
		scale = RTrim(confLine(3))
		' ΏۃtO(0: ΏۊO, 1: Ώ)
		ampFlg = RTrim(confLine(4))
	
		' f[^
		data = ""
		If ampFlg = 1 Then
			If itemType = "char" Then
				index = currentNumber Mod (26 ^ length)
				currentNumber = currentNumber \ (26 ^ length)

				data = makeCharDataByIndex(length, index)
			ElseIf itemType = "number" Then
				index = currentNumber Mod (10 ^ length)
				currentNumber = CInt(currentNumber \ (10 ^ length))

				data = makeNumberDataByIndex(length, scale, index)
			ElseIf itemType = "date" Then
				data = makeDateDataByIndex(i)
			Else
				data = makeTempData(length, scale)
			End If
		Else
			If itemType = "char" Then
				data = makeCharData(length)
			ElseIf itemType = "number" Then
				data = makeNumberData(length, scale)
			ElseIf itemType = "date" Then
				data = FormatDateTime(Date(), vbShortDate)
			Else
				data = makeTempData(length, scale)
			End If
		End If

		If lineData <> "" Then
			lineData = lineData & ","
		End If
		lineData = lineData & data
	Next

	WScript.Echo lineData
Next

' --------------------------------------------------------------------------------

' --------------------------------------------------------------------------------
' ݒt@CǂݍŁADictionaryƂĕԋp
' --------------------------------------------------------------------------------
Function readConfig(fileName)
	' ʂi[DictionaryIuWFNg쐬
	Set result = CreateObject("Scripting.Dictionary")

	' ݒt@CI[v
	Set fs = CreateObject("Scripting.FileSystemObject")
	Set ts = fs.OpenTextFile(fileName)

	' ݒt@Cǂݍ݃[v
	While ts.AtEndOfLine = False
		lineData = ts.readLine()
		lineDataSplit = split(lineData, ",")

		' L[: JAl: J܂ޑSڂ1z
		result.add lineDataSplit(0), lineDataSplit
	Wend

	' ݒt@CN[Y
	ts.close

	Set readConfig = result
End Function
' --------------------------------------------------------------------------------

Const charString = "abcdefghijklmnopqrstuvwxyz"

' --------------------------------------------------------------------------------
' char^̃f[^쐬
' --------------------------------------------------------------------------------
Function makeCharData(length)
	result = ""

	For j=0 to (length-1)
		result = result & Mid(charString, (j Mod len(charString)) + 1, 1)
	Next

	makeCharData = result
End Function
' --------------------------------------------------------------------------------

' --------------------------------------------------------------------------------
' wCfbNXchar^̃f[^쐬
' --------------------------------------------------------------------------------
Function makeCharDataByIndex(length, index)
	result = ""

	current = index
	For j=1 to length
		digit = current mod len(charString)
		result = mid(charString, digit+1, 1) & result
		current = Int(current / len(charString))
	Next

	makeCharDataByIndex = result
End Function
' --------------------------------------------------------------------------------

Const numberString = "1234567890"

' --------------------------------------------------------------------------------
' number^̃f[^쐬
' --------------------------------------------------------------------------------
Function makeNumberData(length, scale)
	result = ""

	If IsNumeric(scale) = False Then
		scale = 0
	End If

	For j=0 to (length - scale - 1)
		result = result & Mid(numberString, (j Mod len(numberString)) + 1, 1)
	Next

	If scale > 0 Then
		result = result & "."
		For j=0 to (scale - 1)
			digit = j + length - scale
			result = result & Mid(numberString, (digit Mod len(numberString)) + 1, 1)
		Next
	End If

	makeNumberData = result
End Function
' --------------------------------------------------------------------------------

Const numberStringForIndex = "0123456789"

' --------------------------------------------------------------------------------
' wCfbNXnumber^̃f[^쐬
' --------------------------------------------------------------------------------
Function makeNumberDataByIndex(length, scale, index)
	result = ""

	If IsNumeric(scale) = False Then
		scale = 0
	End If

	current = index

	If scale > 0 Then
		For j=1 to scale
			digit = current Mod len(numberStringForIndex)
			result = mid(numberStringForIndex, digit+1, 1) & result
			current = Int(current / len(numberStringForIndex))
		Next

		result = "." & result
	End If

	For j=1 to (length - scale)
		digit = current mod len(numberStringForIndex)
		result = mid(numberStringForIndex, digit+1, 1) & result
		current = Int(current / len(numberStringForIndex))
	Next

	makeNumberDataByIndex = result
End Function
' --------------------------------------------------------------------------------

' --------------------------------------------------------------------------------
' wCfbNXdate^̃f[^쐬
' --------------------------------------------------------------------------------
Function makeDateDataByIndex(index)
	currentDate = Date()
	currentDate = DateAdd("d", index, currentDate)

	result = FormatDateTime(currentDate, vbShortDate)

	makeDateDataByIndex = result
End Function
' --------------------------------------------------------------------------------

' --------------------------------------------------------------------------------
' e|f[^쐬
' --------------------------------------------------------------------------------
Function makeTempData(length, scale)
	realLength = length

	If IsNumeric(scale) Then
		If scale > 0 Then
			' _ȉꍇ́A_ȉ̌{_1vX
			realLength = realLength + 1 + scale
		End If
	End If

	makeTempData = makeFixData("@", realLength)
End Function
' --------------------------------------------------------------------------------

' --------------------------------------------------------------------------------
' Œ蕶̃f[^쐬
' --------------------------------------------------------------------------------
Function makeFixData(char, length)
	result = ""

	For j=1 to length
		result = result & char
	Next

	makeFixData = result
End Function
' --------------------------------------------------------------------------------